<?php
header('Content-Type:text/html; charset=UTF-8');

ini_set('display_errors', 1);
ini_set('log_errors', 1);
ini_set('error_log', dirname(__FILE__) . '/error_log.txt');
error_reporting(E_ALL);

require_once ('connect.php');
require_once ('CharacterReferences2utf8.php');

// keep in mind:
// &#39; is single apostrophe (').  This is changed.  I think it causes no problems.
// some fields that have been cut off like thread titles that were too long will never get rid of all &# in the field
// don't worry about these unconverted fields

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="robots" content="noindex,nofollow">
<title>change numerical character entities to UTF-8 characters</title>
</head>

<body>
<?php
if   (isset($_GET['column']))
// 1)	if column is set in query string, set table and columns
{
       if ($_GET['column'] == 'user.username')
        {
         $table1      = "user";
         $primaryKey  = "userid";
         $colWithNCEs = "username";
         $limitRows   = 1000;
        }
       if ($_GET['column'] == 'thread.title')
        {
         $table1      = "thread";
         $primaryKey  = "threadid";
         $colWithNCEs = "title";
         $limitRows   = 1000;
        }
       if ($_GET['column'] == 'post.title')
        {
         $table1      = "post";
         $primaryKey  = "postid";
         $colWithNCEs = "title";
         $limitRows   = 2000;
        }
       if ($_GET['column'] == 'post.pagetext')
        {
         $table1      = "post";
         $primaryKey  = "postid";
         $colWithNCEs = "pagetext";
         $limitRows   = 1000;
        }

// 2) set query and run it
	$query = "SELECT $colWithNCEs, $primaryKey FROM $table1 WHERE $colWithNCEs rlike '&#[0-9]+;' LIMIT $limitRows";
	$result = @mysql_query ($query);
	echo $query . "<br>\n";
}
if (isset($result))
{
 if ($result)
 {
		$val = "";
        while ($row = mysql_fetch_array($result))
        {
                // 3) get row's values
		$primaryKeyR      = $row["$primaryKey"];
                $colWithNCEsR     = $row["$colWithNCEs"];
                $colWithNCEsRUTF8 = stringToUtf8($colWithNCEsR);
                $colWithNCEsRUTF8escaped  = mysql_real_escape_string  ($colWithNCEsRUTF8);
		$val .= "$primaryKeyR $colWithNCEsR $colWithNCEsRUTF8<br>\n";

                // 4) now show changes and maybe update MySQL with UTF-8 values
		$update1 = "UPDATE $table1 SET $colWithNCEs = '$colWithNCEsRUTF8escaped' WHERE $primaryKey = $primaryKeyR";
                echo "$update1<br>\n";
		if   (isset($_GET['run']))
		{
			if ($_GET['run'] == 'true')
			{
				@mysql_query ($update1);
			}
		}
        }
 }
}
?>
<p>
<? 
if (isset($table1)) {echo "Column $colWithNCEs from $table1:";}
?>
<br>
<?
if (isset($val)){echo "$val";}
?>
</p>
<p>
Add querystring to test:<br>
?column=user.username<br>
?column=thread.title<br>
?column=post.title<br>
?column=post.pagetext<br>

View source of page to see the encoding.  You should see the &# 1234 ; and the converted-to-UTF-8 encoded characters in the same line<br>
<br>
To run it after testing add:<br>
&run=true
</p>
</body>
</html>

